/****************************************************
exercice  1: Valider la syntaxe d'adresses email

	auteur : PFZ
   	origine: TP LANGDOC OCT 2004
        version: OCT 2006 

1.1: Extraire les emails sans ""

Traduire dans un analyseur Lex
les rgles ci-dessous inspires de la norme RFC 822 pour valider la syntaxe des adresses email

----------------------------------------------------------------------
1. on ne s'interesse qu'aux adresses de la forme: user@hostname

2. "user" et "hostname" sont des suites d'atomes(string) spars par "." 

3. dans les atomes les caratres: ".,|;\t\n @ ne sont pas autoriss

4. le "user" comporte au moins un atome non vide

5. le "hostname" se compose de 1 ou plusieurs atomes "sous-domaines" et se termine par un atome "toplevel"

6. les "sous-domaines" commencent par une lettre

7. le "toplevel" ne comporte que des lettres (au moins 2)

Ext. (non faite) les "" sont permis seulement par paire dans les atomes avant le "@" et entre les "" on accepte n'importe quoi sauf " et \n

*****************************************************/
%option yylineno
%{
  int bonEmail = 0;
%}
GUIL	\"[^"\n]*\"
SSDOM	([a-zA-Z][^,;.@| \t\n"]*)
TOPDOM	[a-zA-Z][a-zA-Z]+
ATOM	([^,;.|@ \t\n"])+ 		
ADR	{ATOM}("."{ATOM})*"@"({SSDOM}".")+{TOPDOM}
ESP	[ \t]*
%%
{ADR}				{ECHO; printf("\n"); bonEmail++; }
"<"{ESP}{ADR}{ESP}">"   	{ECHO; printf("\n"); bonEmail++; }
.|\n    				;
%%
/* flush pour yylex() */
int yywrap() { printf("\n"); return 1 ;}

main() {
printf("Lecture des emails:\n");
yylex() ;
 printf("emails valides = %d / %d \n", bonEmail, yylineno);
}
/* ATTENTION: RETOUR CHARIOT OBLIGATOIRE POUR LIRE LA DERNIERE LIGNE */

